/***********************************************************************/
/*                                                                     */
/*  This product contains:                                             */
/*     "Restricted Materials of IBM"                                   */
/*     (c) Copyright 1986, 1995 IBM Corp.                              */
/*     All Rights Reserved                                             */
/*     Licensed Materials-Property of IBM                              */
/*     Program Number:   5765-505                                      */
/*     Program Name:     IBM AIX Print Services Facility/6000          */
/*                                                                     */
/*  THIS PROGRAM IS PROVIDED ON AN "AS-IS" BASIS AND NO                */
/*  SUPPORT OR MAINTENANCE WILL BE PROVIDED WITH RESPECT TO THIS       */
/*  PROGRAM SAMPLE.  The licensee of the PSF product is free to        */
/*  copy, revise, modify, and make derivative works of this program    */
/*  sample as they see fit.                                            */
/*  The licensee of this sample code may not resell this code or       */
/*  include it in a product that is resold.                            */
/*                                                                     */
/***********************************************************************/

#define CHAR	char
#define USHORT	unsigned short
#define ULONG	unsigned long

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lprafp.h"

#define FALSE   0
#define TRUE    1

#include <sys/types.h>
#ifndef WIN32
#include <pwd.h>
#endif

#ifdef DEC_SRC
char *strdup(char *string1)
{
  char *string2;

  string2 = malloc( strlen(string1) ); 
  strcpy (string2, string1);
  return string2;
}
#endif

void getopts( char *argv[], char *files, char *lpdopts)
{
   int    c;
   char   *new;
   /*
      opMsg is used to record the pointer to the -m argument value, if any.
      This value must be passed at the end of the parameter string, so that
      the newline munging on the AIX side won't treat the arguments after the
      message as the extension of the message.
   */
   char   *opMsg ;
   int    temp;
    struct passwd *pw;

   *files = 0;
   opMsg = (char *)0 ; 
   ++argv;
   while ( *argv && (c = **argv)) {
      switch (c) {
      case '-':
         c = *((*argv)+1);
         switch (c) {
#if defined(LPR)
         case 'n':
            quietflag = TRUE;
            break;
#endif
#if defined(LPRMON)
         case 'n':
            nobeep = TRUE;
            break;
#endif
/****************************************************************************/
/*       case 'f':                                                          */
/*          fflag = TRUE;                                                   */
/*          if (bflag) {                                                    */
/*             fprintf(stderr,"Cannot specify -f and -b flags together!\n");*/
/*             usage();                                                     */
/*             exit(1);                                                     */
/*          } else {                                                        */
/*             fflag = TRUE;                                                */
/*          }                                                               */
/*          break;                                                          */
/*       case 'b':                                                          */
/*          if (fflag) {                                                    */
/*             fprintf(stderr,"Cannot specify -f and -b flags together!\n");*/
/*             usage();                                                     */
/*             exit(1);                                                     */
/*          } else {                                                        */
/*             bflag = TRUE;                                                */
/*          }                                                               */
/*          break;                                                          */
/****************************************************************************/
         case 'q':
            if (*((*argv)+2)) {           /* -q<delay>    */
               temp = atoi((*argv)+2);
               if ((temp < 0 ) || (temp > 30 )) {
                  fprintf(stderr,"Invalid delay specified!\n");
                  fprintf(stderr,"Respecify with 0 <= delay <= 30\n");
                  usage();
                  exit(1);
               } /* endif */
               delay = temp * 1000L;
            } else {                      /* -q <delay>   */
               if (*(++argv)) {
                  temp = atoi(*argv);
                  if ((temp < 0 ) || (temp > 30 )) {
                     fprintf(stderr,"Invalid delay specified!\n");
                     fprintf(stderr,"Respecify with 0 <= delay <= 30\n");
                     usage();
                     exit(1);
                  } /* endif */
                  delay = temp * 1000L;
               } /* endif */
            } /* endif */
            break;
         case 'r':
            if (*((*argv)+2)) {           /* -r<retries>  */
               temp = atoi((*argv)+2);
               if ((temp < 0 ) || (temp > 5 )) {
                  fprintf(stderr,"Invalid Number of retries specified!\n");
                  fprintf(stderr,"Respecify with 0 <= retries <= 5\n");
                  usage();
                  exit(1);
               } /* endif */
               retries = temp;
            } else {                      /* -r <retries> */
               if (*(++argv)) {
                  temp = atoi(*argv);
                  if ((temp < 0 ) || (temp > 5 )) {
                     fprintf(stderr,"Invalid Number of retries specified!\n");
                     fprintf(stderr,"Respecify with 0 <= retries <= 5\n");
                     usage();
                     exit(1);
                  } /* endif */
                  retries = temp;
               } /* endif */
            } /* endif */
            break;
         case 's':
            if (*((*argv)+2)) {           /* -s<server>   */
               server = (*argv)+2;
            } else {                      /* -s <server>  */
               if (*(++argv)) {
                  server = *argv;
               } /* endif */
            } /* endif */
            break;
         case 'p':
            if (*((*argv)+2)) {           /* -p<printer>  */
               strcpy(printer,(*argv)+2);
            } else {                      /* -p <printer> */
               if (*(++argv)) {
                  strcpy(printer,*argv);
               } /* endif */
            } /* endif */
            break;
         case 'm':
            if (*((*argv)+2)) {           /* -m<message>  */
               opMsg = (*argv)+2;
            } else {                      /* -m <message> */
               if (*(++argv)) {
                  opMsg = *argv;
               } /* endif */
            } /* endif */
            break;
         case 'N':
            if (*((*argv)+2)) {           /* -N<filename>  */
               givenfilename = (*argv)+2;
            } else {                      /* -N <filename> */
               if (*(++argv)) {
                  givenfilename = *argv;
               } /* endif */
            } /* endif */
            break;
         case '?':
            usage();
            exit(1);
            break;
         case 'o':
            strcat(lpdopts,*argv);
            if (!(*((*argv)+2))) {           /* -o<xxxxxxx>  */
               if (*(++argv)) {
                  strcat(lpdopts,*argv);
               } /* endif */
            } /* endif */
            strcat(lpdopts,"\n");
            break;
         default:
            printf("Warning: unknown Option '%c'\n",c);
            strcat(lpdopts,*argv);
            if (!(*((*argv)+2))) {           /* -?<xxxxxxx>  */
               if (*(++argv)) {
                  strcat(lpdopts,*argv);
               } /* endif */
            } /* endif */
            strcat(lpdopts,"\n");
         } /* endswitch */
         break;
      default:
         strcat(files,*argv);
         strcat(files, ";");
      } /* endswitch */
      if(*argv)
         ++argv;
   } /* endwhile */

   if(!*printer) {
      if((new = getenv("LPR_PRINTER")) != NULL) {
         strcpy(printer,new);
      } else {
/*       strcpy(printer,"lp"); */
         printf("No Printer was specified!\n");
         usage();
         exit(1);
      } /* endif */
   } /* endif */

   if(!server) {
      if((new = getenv("LPR_SERVER")) != NULL) {
         server = new;
      } else {
         printf("No Server was specified!\n");
         usage();
         exit(1);
      } /* endif */
   } /* endif */

   /* add the operator message to the end of the lpdopts */

   if ( opMsg != (char *)0 )
     {
       strcat( lpdopts, "-m " );
       strcat( lpdopts, opMsg ) ;
       strcat( lpdopts, "\n" ) ;
     }

   /* 
   if(*lpdopts)
      printf("Warning: Sending unknown options to the server!\n");
   */

#ifndef WIN32
   if ((pw = getpwuid(getuid())) != NULL)
   {
     strcpy(user, pw->pw_name);
   }
   else
   {
     strcpy(user,"pc-user");
   }
#else
   strcpy(user, "win-user");
#endif
}
